statelessrule("Lock project except links", model.Event.BEFORE_FLUSH, function(ctx) {
  return !safeCall(ctx.issue,"isChanged", ["relates to"], false) && !safeCall(ctx.issue,"isChanged", ["subtask of"], false) && !safeCall(ctx.issue,"isChanged", ["parent for"], false) && !safeCall(ctx.issue,"isChanged", ["duplicates"], false) && !safeCall(ctx.issue,"isChanged", ["is duplicated by"], false) && !safeCall(ctx.issue,"isChanged", ["depends on"], false) && !safeCall(ctx.issue,"isChanged", ["is required for"], false);
}, function(ctx) {
  assert(ctx, false,"This project is archived and cannot be edited.");
}).addRequirements(requirements([{name: "Issue", fields: [{name: "Subtask", type: {name: "IssueLinkPrototype", multiple: true, fields: [{name: "parent for", type: {name: "Issue", multiple: true}}, {name: "subtask of", type: {name: "Issue", multiple: true}}]}}, {name: "Relates", type: {name: "IssueLinkPrototype", multiple: true, fields: [{name: "relates to", type: {name: "Issue", multiple: true}}]}}, {name: "Duplicate", type: {name: "IssueLinkPrototype", multiple: true, fields: [{name: "is duplicated by", type: {name: "Issue", multiple: true}}, {name: "duplicates", type: {name: "Issue", multiple: true}}]}}, {name: "Depend", type: {name: "IssueLinkPrototype", multiple: true, fields: [{name: "is required for", type: {name: "Issue", multiple: true}}, {name: "depends on", type: {name: "Issue", multiple: true}}]}}]}]));